/**
 * LOGICAL-PARADOX.ORG
 * Copyright (C)2004 satoshi akabane(akabane@logical-paradox.org)
 *
 */
package org.logical_paradox.shell;

import java.util.Hashtable;

import org.logical_paradox.shell.exception.CommandExecutionException;

/**
 * [hꂽR}ho^ĂIuWFNg
 * 
 * @author satoshi akabane@logical-paradox.org
 * @version $Revision: 1.5 $
 */
public class Commands {
	/**
	 * JVMŗB̃R}h
	 */
	private static final Hashtable commands = new Hashtable();
	private static DynamicCommandLoader loader = null;

	/**
	 * RXgN^
	 * @param se VFϐ
	 */
	public Commands(ShellEnv se) {
		if(loader == null) {
			loader = new DynamicCommandLoader(se);
		}
	}
	/**
	 * R}ho^
	 * @param command o^R}h
	 */
	public static void register(Command command) {
		commands.put(command.toString(), command);
	}
	/**
	 * R}ho^
	 * @param command R}h
	 */
	public static void unregister(Command command) {
		unregister(command.toString());
	}
	/**
	 * R}ho^
	 * @param command R}h
	 */
	public static void unregister(String command) {
		commands.remove(command);
	}
	/**
	 * R}hɃ[hĂ邩ǂԂ
	 * @param name [hR}h
	 * @return true:[hĂ / false:[hĂȂ
	 */
	public boolean isLoaded(String name) {
		if(commands.get(name) == null) {
			return false;
		} else {
			return true;
		}
	}
	/**
	 * w薼̂ɑΉR}hԂ
	 * @param name R}h
	 * @return R}hNX
	 * @throws CommandExecutionException [hɎs
	 */
	public Command getCommand(String name) throws CommandExecutionException {
		Command command = (Command)commands.get(name);
		if(isLoaded(name) == false) {
			// R}hNX[h
			try {
				command = loader.load(name);
				commands.put(name, command);
			} catch (InstantiationException e) {
				e.printStackTrace();
			} catch (IllegalAccessException e) {
				e.printStackTrace();
			}
		}
		return command;
	}
}
