/**
 * LOGICAL-PARADOX.ORG variable record manager library
 * Copyright (C)2004 satoshi akabane(akabane@logical-paradox.org)
 *
 * Release 1.0
 * Ep[W
 */
package org.logical_paradox.common.vrm;

import java.io.IOException;
import java.util.Collection;
import java.util.LinkedList;

import org.logical_paradox.common.io.MemoryMappedRandomAccessFile;

/**
 * Ŏs\VariableRecordManager
 * 
 * @author satoshi akabane@logical-paradox.org
 * @version 1.0
 */
public class VariableRecordManagerMoc extends VariableRecordManager {
	private LinkedList records = new LinkedList();

	/**
	 * RXgN^
	 * @param filename ǗΏۂ̃t@C
	 * @throws IOException t@CANZXɎs
	 */
	public VariableRecordManagerMoc(String filename, RecordFactory factory) throws IOException {
		super(filename, factory);
	}

	/**
	 * t@CI[v
	 * hNXŕʂ̃^Cṽt@CI[vꍇC̃\bhI[o[Ch
	 * @throws IOException I[vɎs
	 */
	public void open() throws IOException {
		// ǂݏ[hRandomAccessFileI[v
		file = new MemoryMappedRandomAccessFile();
		availableList = new VRMAvailableListMoc(filename + ".vra");
	}

	// f[^폜
	public void delete(long rno) throws IOException {
		super.delete(rno);
		records.remove(new Long(rno));
	}

	// f[^o^
	public long insert(Record r) throws IOException {
		long rno = super.insert(r);
		records.add(new Long(rno));
		return rno;
	}

	// f[^XV
	public void update(long rno, Record r) throws IOException {
		super.update(rno, r);
	}
	// LR[h̃XgԂ
	public Collection getRecordNumbers() {
		return records;
	}
}
