/*
 * LOGICAL-PARADOX.ORG
 * Copyright (C)2005 satoshi akabane(akabane@logical-paradox.org)
 * $Id: RMILookup.java,v 1.2 2005/09/07 13:38:06 rampil Exp $
 */
package org.logical_paradox.vsan.lookup;

import java.rmi.Naming;
import java.rmi.RemoteException;

import org.logical_paradox.vsan.dfs.DomainFileSystem;
import org.logical_paradox.vsan.domain.DomainController;

/**
 * RMIgp^CṽT[rXIuWFNg
 * @author satoshi akabane@logical-paradox.org
 * @version $Revision: 1.2 $
 */
public class RMILookup implements Lookup {
	/**
	 * hCoCh
	 * @param dcn hC
	 * @param dc hCRg[[
	 * @throws oChɎs
	 */
	public void registerDomainController(DomainController dc) throws LookupException {
		try {
			Naming.rebind(dc.getName(), dc);
		} catch (Exception e) {
			throw new LookupException(e.getMessage());
		}
	}
	/**
	 * hCt@CVXeoCh
	 * @param domain hC
	 * @param dfs hCt@CVXe
	 * @throws LookupException oChɎs
	 */
	public void registerDomainFileSystem(DomainFileSystem dfs) throws LookupException {
		try {
			Naming.rebind(dfs.getNodeId(), dfs);
		} catch (Exception e) {
			throw new LookupException(e.getMessage());
		}
	}
	/**
	 * rmiregistry
	 * @param name T[o[
	 * @return 擾łIuWFNg
	 * @throws RemoteException ɔO
	 */
	protected Object rmiLookup(String name) throws RemoteException {
		try {
			Object o = Naming.lookup(name);
			return o;
		} catch (RemoteException e) {
			throw e;
		} catch (Exception e) {
			e.printStackTrace();
			throw new RemoteException(e.getMessage());
		}
	}
	/**
	 * w薼̂̃hCRg[[T
	 * @param dcn hCRg[[̎ʎq
	 * @return 擾łhCRg[[̃X^u
	 * @throws LookupException Ɏs
	 */
	public DomainController lookupDomainController(String dcn) throws LookupException {
		try {
			DomainController dc = (DomainController)rmiLookup(dcn);
			return dc;
		} catch(RemoteException e) {
			throw new LookupException(e.getMessage());
		}
	}
	/**
	 * w薼̂̃hCt@CVXeT
	 * @param domain hC
	 * @return 擾łhCt@CVXẽX^u
	 * @throws LookupException Ɏs
	 */
	public DomainFileSystem lookupDomainFileSystem(String domain) throws LookupException {
		try {
			DomainFileSystem dfs = (DomainFileSystem)rmiLookup(domain);
			return dfs;
		} catch(RemoteException e) {
			throw new LookupException(e.getMessage());
		}
	}

}
