/*
 * LOGICAL-PARADOX.ORG
 * Copyright (C)2005 satoshi akabane(akabane@logical-paradox.org)
 * $Id: RecordSet.java,v 1.2 2005/09/07 13:38:06 rampil Exp $
 */
package org.logical_paradox.vsan.node.dbr;

import java.io.Serializable;

import org.logical_paradox.common.util.StringUtils;

/**
 * R[h͈̓NX
 * @author satoshi akabane@logical-paradox.org
 * @version $Revision: 1.2 $
 */
public class RecordSet implements Serializable {
	/** ǗĂ郌R[h͈̔(Jn) */
	private final long recordBegin;
	/** ǗĂ郌R[h͈̔(I) */
	private final long recordEnd;
	/** ǗĂ郌R[h̃TCY */
	private final int recordSize;

	public RecordSet(long recordBegin_, long recordEnd_, int recordSize_) {
		recordBegin = recordBegin_;
		recordEnd = recordEnd_;
		recordSize = recordSize_;
	}
	/**
	 * w肳ꂽR[hԍÃR[hZbg܂ނǂԂ
	 * @param rno ΏۃR[hԍ
	 * @return true:܂ / false:܂܂Ȃ
	 */
	public boolean includes(long rno) {
		return getRecordBegin() <= rno && getRecordEnd() >= rno;
	}
	/**
	 * R[h͈(Jn)Ԃ
	 * @return R[h͈(Jn)
	 */
	public long getRecordBegin() {
		return recordBegin;
	}
	/**
	 * R[h͈(I)Ԃ
	 * @return R[h͈(I)
	 */
	public long getRecordEnd() {
		return recordEnd;
	}
	/**
	 * R[hTCYԂ
	 * @return R[hTCY
	 */
	public int getRecordSize() {
		return recordSize;
	}
	/**
	 * ̃R[hZbgLf[^TCYԂD
	 * @return Lf[^TCY
	 */
	public long getSize() {
		return (recordEnd - recordBegin) * recordSize;
	}
	/**
	 * ̃R[hZbg̕\ԂB
	 * @return R[h̕\
	 */
	public String toString() {
		return StringUtils.formatColumns(getRecordBegin(), 10) + "_" + StringUtils.formatColumns(getRecordEnd(), 10);
	}
}
