/*
 * LOGICAL-PARADOX.ORG b-tree library
 * Copyright (C)2004,2005 satoshi akabane(akabane@logical-paradox.org)
 * $Id: OnMemoryBtreeFile.java,v 1.2 2005/05/16 15:36:45 rampil Exp $
 */
package org.logical_paradox.common.btree;

import org.logical_paradox.common.io.MemoryMappedRandomAccessFile;
import org.logical_paradox.common.io.RandomAccessFileDelegator;

/**
 * Iœ삷BtreeFile
 * @author satoshi akabane@logical-paradox.org
 * @version $Revision: 1.2 $
 */
public class OnMemoryBtreeFile extends BtreeFile {
	/**
	 * t@CI[v
	 * @param filename t@C
	 * @return t@Cւ̎Q
	 * @throws Exception 炩̗Oꍇ
	 */
	protected RandomAccessFileDelegator openPhysicalFile(String filename) throws Exception {
		_fragment = new OnMemoryBtreeFragmentFile();
		return new MemoryMappedRandomAccessFile();
	}
}
