/*
 * LOGICAL-PARADOX.ORG
 * Copyright (C)2005 satoshi akabane(akabane@logical-paradox.org)
 * $Id: Protocol.java,v 1.2 2005/09/07 13:38:07 rampil Exp $
 */
package org.logical_paradox.vsan.dac.command;

/**
 * DACvgR
 * @author satoshi akabane@logical-paradox.org
 * @version $Revision: 1.2 $
 */
public interface Protocol {
	/** VZbVI[v */
	public static final int P_OPEN_SESSION = 0x10;
	/** ̃ZbVN[Y */
	public static final int P_CLOSE_SESSION = 0x11;
	/** hCɎQf[^t@CtH[}bg */
	public static final int P_FORMAT = 0x20;
	/** f[^t@C̗̈œK */
	public static final int P_OPTIMIZE = 0x21;
	/** f[^t@C̗̈g */
	public static final int P_EXPAND_DATAF = 0x22;
	/** hCf[^x[X̔j */
	public static final int P_DISPOSE = 0x2f;
	/** bN */
	public static final int P_LOCK = 0x30;
	/** AbN */
	public static final int P_UNLOCK = 0x31;
	/** f[^XgA */
	public static final int P_STORE = 0x38;
	/** f[^XgA */
	public static final int P_RESTORE = 0x39;
	/** f[^g[u */
	public static final int P_RETRIEVE = 0x3a;
	/** Xe[^X|[gv */
	public static final int P_STATUS_REPORT = 0xf0;
	/** fBXNACRg[[̍ċN */
	public static final int P_REBOOT = 0x0fd;
	/** Vbg_E */
	public static final int P_SHUTDOWN = 0xff;
}
