/*
 * LOGICAL-PARADOX.ORG
 * Copyright (C)2005 satoshi akabane(akabane@logical-paradox.org)
 * $Id: HashMapLookup.java,v 1.2 2005/09/07 13:38:06 rampil Exp $
 */
package org.logical_paradox.vsan.lookup;

import java.rmi.RemoteException;
import java.util.HashMap;

import org.logical_paradox.vsan.dfs.DomainFileSystem;
import org.logical_paradox.vsan.domain.DomainController;

/**
 * HashMapgpAT[rXIuWFNg
 * @author satoshi akabane@logical-paradox.org
 * @version $Revision: 1.2 $
 */
public class HashMapLookup implements Lookup {
	/** WXg */
	private static final HashMap registry = new HashMap();

	/**
	 * hCoCh
	 * @param dc hCRg[[
	 * @throws oChɎs
	 */
	public void registerDomainController(DomainController dc) throws LookupException {
		try {
			registry.put(dc.getName(), dc);
		} catch (RemoteException e) {
			throw new LookupException(e.getMessage());
		}
	}
	/**
	 * hCt@CVXeoCh
	 * @param dfs hCt@CVXe
	 * @throws LookupException oChɎs
	 */
	public void registerDomainFileSystem(DomainFileSystem dfs) throws LookupException {
		try {
			registry.put(dfs.getNodeId(), dfs);
		} catch (RemoteException e) {
			throw new LookupException(e.getMessage());
		}
	}
	/**
	 * w薼̂̃hCRg[[T
	 * @param dcn hCRg[[̎ʎq
	 * @return 擾łhCRg[[̃X^u
	 * @throws LookupException Ɏs
	 */
	public DomainController lookupDomainController(String dcn) throws LookupException {
		DomainController dc = (DomainController)registry.get(dcn);
		if(dc == null) {
			throw new LookupException();
		}
		return dc;
	}
	/**
	 * w薼̂̃hCt@CVXeT
	 * @param domain hC
	 * @return 擾łhCt@CVXẽX^u
	 * @throws LookupException Ɏs
	 */
	public DomainFileSystem lookupDomainFileSystem(String domain) throws LookupException {
		DomainFileSystem dfs = (DomainFileSystem)registry.get(domain);
		if(dfs == null) {
			throw new LookupException();
		}
		return dfs;
	}

}
