/*
 * LOGICAL-PARADOX.ORG
 * Copyright (C)2005 satoshi akabane(akabane@logical-paradox.org)
 * $Id: AbstractApi.java,v 1.2 2005/09/07 13:38:06 rampil Exp $
 */
package org.logical_paradox.vsan.node;

import java.util.ArrayList;
import java.util.Collections;
import java.util.List;


/**
 * APINX
 * @author satoshi akabane@logical-paradox.org
 * @version $Revision: 1.2 $
 */
public abstract class AbstractApi {
	/** Ώۃf[^x[X */
	private final Database database;

	/**
	 * RXgN^
	 * @param db f[^x[X
	 */
	protected AbstractApi(Database db) {
		database = db;
	}
	/**
	 * hCf[^x[XԂ
	 * @return hCf[^x[X
	 */
	protected Database getDatabase() {
		return database;
	}
	/**
	 * f[^t@C̃XgԂ
	 * @return f[^t@C̃Xg
	 */
	protected List getDatafiles() {
		return database.getDatafiles();
	}
	/**
	 * R[hԍɃ\[gĂf[^t@C̃XgԂ
	 * @return Ƀ\[gꂽf[^t@C̃Xg
	 */
	protected List getSortedDatafiles() {
		List datafiles = getDatafiles();

		// Ń\[g(JnR[hԍ)
		List dbfiles = new ArrayList();
		dbfiles.addAll(datafiles);

		Collections.sort(dbfiles);

		return dbfiles;
	}
}
