/*
 * LOGICAL-PARADOX.ORG
 * Copyright (C)2005 satoshi akabane(akabane@logical-paradox.org)
 * $Id: SocketWriter.java,v 1.3 2005/09/17 17:36:00 rampil Exp $
 */
package org.logical_paradox.vsan.tools.console.util;

import java.io.BufferedInputStream;
import java.io.BufferedOutputStream;
import java.io.IOException;
import java.net.Socket;

import org.logical_paradox.common.io.ExpandableBuffer;
import org.logical_paradox.common.util.ByteStreamConverter;
import org.logical_paradox.common.util.StringUtils;
import org.logical_paradox.vsan.dac.DacConfig;
import org.logical_paradox.vsan.dac.Response;

/**
 * \PbgC^[
 * DACɑ΂ăf[^𑗐M܂
 * @author satoshi akabane@logical-paradox.org
 * @version $Revision: 1.3 $
 */
public class SocketWriter {
	/**
	 * f[^DACɑ΂đM܂
	 * 炩̉񓚂΁A񓚂ꂽf[^Ԃ܂<br>
	 * ignoreIvVtrueݒ肷ƁAʐMɔI/OO𖳎܂
	 * @param dac ڑ
	 * @param data Mf[^
	 * @param ignore G[tO(true: / false:񍐂)
	 * @return DAC̉
	 * @throws IOException ʐMɔI/OO
	 */
	public static final Response send(String dac, byte[] data, boolean ignore) throws IOException {
		if(StringUtils.isEmpty(dac) == true) {
			dac = "localhost";
		}

		// \Pbg쐬
		Socket socket = null;
		if(dac.indexOf(":") == dac.lastIndexOf(":")) {
			String[] tokens = dac.split(":");
			if(tokens.length == 1) {
				socket = new Socket(tokens[0], DacConfig.DEFAULT_PORT_NUMBER);
			} else {
				socket = new Socket(tokens[0], Integer.parseInt(tokens[1]));
			}
		} else {
			throw new IOException("illegal host format for 'dac'.");
		}

		byte[] rc = new byte[0];
		int resultcode = -1;

		try {
			// ʐM
			BufferedOutputStream bw = new BufferedOutputStream(socket.getOutputStream());
			bw.write(data);
			bw.flush();

			// f[^M
			ExpandableBuffer exb = new ExpandableBuffer();

			// pPbgM
			BufferedInputStream bi = new BufferedInputStream(socket.getInputStream());

			// sXe[^XM
			byte[] status = new byte[4];
			bi.read(status);
			resultcode = ByteStreamConverter.getInt(status);

			byte[] packetnum = new byte[4];
			bi.read(packetnum);

			int packets = ByteStreamConverter.getInt(packetnum);

			// pPbg̓ǂݍ
			byte[] packetsz = new byte[4];
			for(int i = 0; i < packets; i++) {
				bi.read(packetsz);
				int packetlen = ByteStreamConverter.getInt(packetsz);
				byte[] body = new byte[packetlen];

				// f[^̎M
				bi.read(body);
				exb.write(body);
			}

			// SẴpPbg̎M̂Ń\Pbg
			socket.close();

			rc = exb.byteStream();
		} catch(IOException e) {
			if(ignore == false) {
				throw e;
			}
		}
		return new Response(resultcode, rc);
	}
}
